#ifndef TANGO_COMPILE_PHASE_HPP
#define TANGO_COMPILE_PHASE_HPP

#include "tango/compilation_session.hpp"

namespace tango {

//-------------------------------------------------------------//
// Base class for all phase of codegeneration
// All phases should derived from it if possible
class CompilePhase {
 public:
  CompilePhase(Ir* ir, PhaseName name):
    _ir(ir),
    _name(name) {}

  void run() {
    session.startPhase(_name);
    run_internal();
    session.endPhase();
  }

  virtual ~CompilePhase() {}

 protected:
  virtual void run_internal() = 0;

 protected:
  Ir*       _ir;
  PhaseName _name;
};

//-------------------------------------------------------------//

} // namespace tango
#endif // TANGO_COMPILE_PHASE_HPP
